summaryrefslogtreecommitdiffstats
path: root/office/texlive
diff options
context:
space:
mode:
author Johannes Schoepfer <slackbuilds[at]schoepfer[dot]info>2017-10-06 16:47:51 +0100
committer David Spencer <idlemoor@slackbuilds.org>2017-10-06 16:48:31 +0100
commitf5f5d046db444f85493872f06b3d49c9e646dea0 (patch)
treeec75448d5a54c99c9720b86f9fb13588d935ef33 /office/texlive
parentba7879d9ba0a6b8664337d690d80c55212e0ef9f (diff)
downloadslackbuilds-f5f5d046db444f85493872f06b3d49c9e646dea0.tar.gz
slackbuilds-f5f5d046db444f85493872f06b3d49c9e646dea0.tar.xz
office/texlive: Updated SlackBuild for -current compatibility.
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'office/texlive')
-rw-r--r--office/texlive/README.tlpkg1
-rw-r--r--office/texlive/doinst.sh1
-rw-r--r--office/texlive/patches/texlive-poppler-0.59.patch1142
-rw-r--r--office/texlive/prep/dump.unused.internal.libraries.from.sources.sh15
-rw-r--r--office/texlive/prep/texmf_get.sh280
-rw-r--r--office/texlive/slack-desc16
-rw-r--r--office/texlive/texlive.SlackBuild49
-rw-r--r--office/texlive/texlive.info2
8 files changed, 1295 insertions, 211 deletions
diff --git a/office/texlive/README.tlpkg b/office/texlive/README.tlpkg
index 35c25dd256..7a6f790ca8 100644
--- a/office/texlive/README.tlpkg
+++ b/office/texlive/README.tlpkg
@@ -15,4 +15,3 @@ make it:
then we would love to hear from you. :-)
--rworkman :-)
-
diff --git a/office/texlive/doinst.sh b/office/texlive/doinst.sh
index 91d48effca..5839d51680 100644
--- a/office/texlive/doinst.sh
+++ b/office/texlive/doinst.sh
@@ -1,4 +1,3 @@
-rm -f usr/share/texmf-config/web2c/updmap.cfg
chroot . /usr/bin/mktexlsr 1>/dev/null 2>/dev/null
printf "y\n" | chroot . /usr/bin/updmap-sys --nohash --syncwithtrees 1>/dev/null 2>/dev/null
chroot . /usr/bin/fmtutil-sys --all 1>/dev/null 2>/dev/null
diff --git a/office/texlive/patches/texlive-poppler-0.59.patch b/office/texlive/patches/texlive-poppler-0.59.patch
new file mode 100644
index 0000000000..401315a64c
--- /dev/null
+++ b/office/texlive/patches/texlive-poppler-0.59.patch
@@ -0,0 +1,1142 @@
+diff -ur source.orig/texk/web2c/luatexdir/image/pdftoepdf.w source/texk/web2c/luatexdir/image/pdftoepdf.w
+--- source.orig/texk/web2c/luatexdir/image/pdftoepdf.w 2017-05-08 22:39:36.639375783 +0200
++++ source/texk/web2c/luatexdir/image/pdftoepdf.w 2017-09-19 11:23:36.586768739 +0200
+@@ -224,7 +224,7 @@
+ free(checksum);
+ }
+ if (pdf_doc->doc == NULL) {
+- docmemstream = new MemStream( docstream,0,streamsize, obj.initNull() );
++ docmemstream = new MemStream( docstream,0,streamsize, Object(objNull) );
+ doc = new PDFDoc(docmemstream); /* takes ownership of docmemstream */
+ pdf_doc->pc++;
+ if (!doc->isOk() || !doc->okToPrint()) {
+@@ -408,9 +408,8 @@
+ Object obj1;
+ pdf_begin_array(pdf);
+ for (i = 0, l = array->getLength(); i < l; ++i) {
+- array->getNF(i, &obj1);
++ obj1 = array->getNF(i);
+ copyObject(pdf, pdf_doc, &obj1);
+- obj1.free();
+ }
+ pdf_end_array(pdf);
+ }
+@@ -422,9 +421,8 @@
+ pdf_begin_dict(pdf);
+ for (i = 0, l = dict->getLength(); i < l; ++i) {
+ copyName(pdf, dict->getKey(i));
+- dict->getValNF(i, &obj1);
++ obj1 = dict->getValNF(i);
+ copyObject(pdf, pdf_doc, &obj1);
+- obj1.free();
+ }
+ pdf_end_dict(pdf);
+ }
+@@ -510,13 +508,12 @@
+ PDFDoc *doc = pdf_doc->doc;
+ xref = doc->getXRef();
+ for (r = pdf_doc->inObjList; r != NULL;) {
+- xref->fetch(r->ref.num, r->ref.gen, &obj1);
++ obj1 = xref->fetch(r->ref.num, r->ref.gen);
+ if (obj1.isStream())
+ pdf_begin_obj(pdf, r->num, OBJSTM_NEVER);
+ else
+ pdf_begin_obj(pdf, r->num, 2);
+ copyObject(pdf, pdf_doc, &obj1);
+- obj1.free();
+ pdf_end_obj(pdf);
+ n = r->next;
+ delete r;
+@@ -740,7 +737,7 @@
+ catalog = doc->getCatalog();
+ page = catalog->getPage(img_pagenum(idict));
+ pageref = catalog->getPageRef(img_pagenum(idict));
+- doc->getXRef()->fetch(pageref->num, pageref->gen, &pageobj);
++ pageobj = doc->getXRef()->fetch(pageref->num, pageref->gen);
+ pageDict = pageobj.getDict();
+ /* write the Page header */
+ pdf_begin_obj(pdf, img_objnum(idict), OBJSTM_NEVER);
+@@ -757,12 +754,11 @@
+ pdf_dict_add_int(pdf, "PTEX.PageNumber", (int) img_pagenum(idict));
+ }
+ if ((suppress_optional_info & 8) == 0) {
+- doc->getDocInfoNF(&obj1);
++ obj1 = doc->getDocInfoNF();
+ if (obj1.isRef()) {
+ /* the info dict must be indirect (PDF Ref p. 61) */
+ pdf_dict_add_ref(pdf, "PTEX.InfoDict", addInObj(pdf, pdf_doc, obj1.getRef()));
+ }
+- obj1.free();
+ }
+ if (img_is_bbox(idict)) {
+ bbox[0] = sp2bp(img_bbox(idict)[0]);
+@@ -788,19 +784,17 @@
+ Now all relevant parts of the Page dictionary are copied. Metadata validity
+ check is needed(as a stream it must be indirect).
+ */
+- pageDict->lookupNF("Metadata", &obj1);
++ obj1 = pageDict->lookupNF("Metadata");
+ if (!obj1.isNull() && !obj1.isRef())
+ formatted_warning("pdf inclusion","/Metadata must be indirect object");
+- obj1.free();
+ /* copy selected items in Page dictionary */
+ for (i = 0; pagedictkeys[i] != NULL; i++) {
+- pageDict->lookupNF(pagedictkeys[i], &obj1);
++ obj1 = pageDict->lookupNF(pagedictkeys[i]);
+ if (!obj1.isNull()) {
+ pdf_add_name(pdf, pagedictkeys[i]);
+ /* preserves indirection */
+ copyObject(pdf, pdf_doc, &obj1);
+ }
+- obj1.free();
+ }
+ /*
+ If there are no Resources in the Page dict of the embedded page,
+@@ -808,32 +802,28 @@
+ PDF file, climbing up the tree until the Resources are found.
+ (This fixes a problem with Scribus 1.3.3.14.)
+ */
+- pageDict->lookupNF("Resources", &obj1);
++ obj1 = pageDict->lookupNF("Resources");
+ if (obj1.isNull()) {
+ op1 = &pagesobj1;
+ op2 = &pagesobj2;
+- pageDict->lookup("Parent", op1);
++ *op1 = pageDict->lookup("Parent");
+ while (op1->isDict()) {
+- obj1.free();
+- op1->dictLookupNF("Resources", &obj1);
++ obj1 = op1->dictLookupNF("Resources");
+ if (!obj1.isNull()) {
+ pdf_add_name(pdf, "Resources");
+ copyObject(pdf, pdf_doc, &obj1);
+ break;
+ }
+- op1->dictLookup("Parent", op2);
++ *op2 = op1->dictLookup("Parent");
+ optmp = op1;
+ op1 = op2;
+ op2 = optmp;
+- op2->free();
+ };
+ if (!op1->isDict())
+ formatted_warning("pdf inclusion","Page /Resources missing");
+- op1->free();
+ }
+- obj1.free();
+ /* Write the Page contents. */
+- page->getContents(&contents);
++ contents = page->getContents();
+ if (contents.isStream()) {
+ /*
+ Variant A: get stream and recompress under control of \pdfcompresslevel
+@@ -844,27 +834,23 @@
+
+ Variant B: copy stream without recompressing
+ */
+- contents.streamGetDict()->lookup("F", &obj1);
++ obj1 = contents.streamGetDict()->lookup("F");
+ if (!obj1.isNull()) {
+ normal_error("pdf inclusion","unsupported external stream");
+ }
+- obj1.free();
+- contents.streamGetDict()->lookup("Length", &obj1);
++ obj1 = contents.streamGetDict()->lookup("Length");
+ pdf_add_name(pdf, "Length");
+ copyObject(pdf, pdf_doc, &obj1);
+- obj1.free();
+- contents.streamGetDict()->lookup("Filter", &obj1);
++ obj1 = contents.streamGetDict()->lookup("Filter");
+ if (!obj1.isNull()) {
+ pdf_add_name(pdf, "Filter");
+ copyObject(pdf, pdf_doc, &obj1);
+- obj1.free();
+- contents.streamGetDict()->lookup("DecodeParms", &obj1);
++ obj1 = contents.streamGetDict()->lookup("DecodeParms");
+ if (!obj1.isNull()) {
+ pdf_add_name(pdf, "DecodeParms");
+ copyObject(pdf, pdf_doc, &obj1);
+ }
+ }
+- obj1.free();
+ pdf_end_dict(pdf);
+ pdf_begin_stream(pdf);
+ copyStreamStream(pdf, contents.getStream()->getUndecodedStream());
+@@ -875,8 +861,8 @@
+ pdf_end_dict(pdf);
+ pdf_begin_stream(pdf);
+ for (i = 0, l = contents.arrayGetLength(); i < l; ++i) {
+- copyStreamStream(pdf, (contents.arrayGet(i, &obj1))->getStream());
+- obj1.free();
++ obj1 = contents.arrayGet(i);
++ copyStreamStream(pdf, obj1.getStream());
+ if (i < (l - 1)) {
+ /*
+ Put a space between streams to be on the safe side (streams
+@@ -897,8 +883,6 @@
+ }
+ /* write out all indirect objects */
+ writeRefs(pdf, pdf_doc);
+- contents.free();
+- pageobj.free();
+ /*
+ unrefPdfDocument() must come after contents.free() and pageobj.free()!
+ TH: The next line makes repeated pdf inclusion unacceptably slow
+diff -ur source.orig/texk/web2c/luatexdir/lua/lepdflib.cc source/texk/web2c/luatexdir/lua/lepdflib.cc
+--- source.orig/texk/web2c/luatexdir/lua/lepdflib.cc 2017-05-08 22:39:36.689375107 +0200
++++ source/texk/web2c/luatexdir/lua/lepdflib.cc 2017-09-19 09:48:19.658021769 +0200
+@@ -538,7 +538,7 @@
+ pdfdoc_changed_error(L); \
+ uout = new_Object_userdata(L); \
+ uout->d = new Object(); \
+- ((in *) uin->d)->function((Object *) uout->d); \
++ *((Object *)uout->d) = ((in *) uin->d)->function(); \
+ uout->atype = ALLOC_LEPDF; \
+ uout->pc = uin->pc; \
+ uout->pd = uin->pd; \
+@@ -668,13 +668,11 @@
+
+ static int m_Array_incRef(lua_State * L)
+ {
+- int i;
+ udstruct *uin;
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Array);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- i = ((Array *) uin->d)->incRef();
+- lua_pushinteger(L, i);
++ lua_pushinteger(L, 1);
+ return 1;
+ }
+
+@@ -685,8 +683,7 @@
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Array);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- i = ((Array *) uin->d)->decRef();
+- lua_pushinteger(L, i);
++ lua_pushinteger(L, 1);
+ return 1;
+ }
+
+@@ -702,7 +699,7 @@
+ if ((uin->pd != NULL && uin->pd->pc != uin->pc)
+ || (uobj->pd != NULL && uobj->pd->pc != uobj->pc))
+ pdfdoc_changed_error(L);
+- ((Array *) uin->d)->add(((Object *) uobj->d));
++ ((Array *) uin->d)->add(std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -718,7 +715,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Array *) uin->d)->get(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Array *) uin->d)->get(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -739,7 +736,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Array *) uin->d)->getNF(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Array *) uin->d)->getNF(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -953,25 +950,21 @@
+
+ static int m_Dict_incRef(lua_State * L)
+ {
+- int i;
+ udstruct *uin;
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Dict);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- i = ((Dict *) uin->d)->incRef();
+- lua_pushinteger(L, i);
++ lua_pushinteger(L, 1);
+ return 1;
+ }
+
+ static int m_Dict_decRef(lua_State * L)
+ {
+- int i;
+ udstruct *uin;
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Dict);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- i = ((Dict *) uin->d)->decRef();
+- lua_pushinteger(L, i);
++ lua_pushinteger(L, 1);
+ return 1;
+ }
+
+@@ -986,7 +979,7 @@
+ pdfdoc_changed_error(L);
+ s = copyString(luaL_checkstring(L, 2));
+ uobj = (udstruct *) luaL_checkudata(L, 3, M_Object);
+- ((Dict *) uin->d)->add(s, ((Object *) uobj->d));
++ ((Dict *) uin->d)->add(s, std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -999,7 +992,7 @@
+ pdfdoc_changed_error(L);
+ s = luaL_checkstring(L, 2);
+ uobj = (udstruct *) luaL_checkudata(L, 3, M_Object);
+- ((Dict *) uin->d)->set(s, ((Object *) uobj->d));
++ ((Dict *) uin->d)->set(s, std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -1027,7 +1020,7 @@
+ s = luaL_checkstring(L, 2);
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Dict *) uin->d)->lookup(s, (Object *) uout->d);
++ *((Object *) uout->d) = ((Dict *) uin->d)->lookup(s);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1044,7 +1037,7 @@
+ s = luaL_checkstring(L, 2);
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Dict *) uin->d)->lookupNF(s, (Object *) uout->d);
++ *((Object *) uout->d) = ((Dict *) uin->d)->lookupNF(s);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1096,7 +1089,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Dict *) uin->d)->getVal(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Dict *) uin->d)->getVal(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1117,7 +1110,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Dict *) uin->d)->getValNF(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Dict *) uin->d)->getValNF(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1381,9 +1374,9 @@
+ pdfdoc_changed_error(L);
+ luaL_checktype(L, 2, LUA_TBOOLEAN);
+ if (lua_toboolean(L, 2) != 0)
+- ((Object *) uin->d)->initBool(gTrue);
++ *((Object *) uin->d) = Object(gTrue);
+ else
+- ((Object *) uin->d)->initBool(gFalse);
++ *((Object *) uin->d) = Object(gFalse);
+ return 0;
+ }
+
+@@ -1395,7 +1388,7 @@
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+ i = luaL_checkint(L, 2);
+- ((Object *) uin->d)->initInt(i);
++ *((Object *) uin->d) = Object(i);
+ return 0;
+ }
+
+@@ -1407,7 +1400,7 @@
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+ d = luaL_checknumber(L, 2);
+- ((Object *) uin->d)->initReal(d);
++ *((Object *) uin->d) = Object(d);
+ return 0;
+ }
+
+@@ -1422,7 +1415,7 @@
+ pdfdoc_changed_error(L);
+ s = luaL_checklstring(L, 2, &len);
+ gs = new GooString(s, len);
+- ((Object *) uin->d)->initString(gs);
++ *((Object *) uin->d) = Object(gs);
+ return 0;
+ }
+
+@@ -1434,7 +1427,7 @@
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+ s = luaL_checkstring(L, 2);
+- ((Object *) uin->d)->initName(s);
++ *((Object *) uin->d) = Object(objName, s);
+ return 0;
+ }
+
+@@ -1444,13 +1437,14 @@
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Object);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initNull();
++ *((Object *) uin->d) = Object(objNull);
+ return 0;
+ }
+
+ static int m_Object_initArray(lua_State * L)
+ {
+ udstruct *uin, *uxref;
++ Array *a;
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Object);
+ uxref = (udstruct *) luaL_checkudata(L, 2, M_XRef);
+ if (uin->pd != NULL && uxref->pd != NULL && uin->pd != uxref->pd)
+@@ -1458,7 +1452,8 @@
+ if ((uin->pd != NULL && uin->pd->pc != uin->pc)
+ || (uxref->pd != NULL && uxref->pd->pc != uxref->pc))
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initArray((XRef *) uxref->d);
++ a = new Array((XRef *) uxref->d);
++ *((Object *) uin->d) = Object(a);
+ return 0;
+ }
+
+@@ -1469,6 +1464,7 @@
+ static int m_Object_initDict(lua_State * L)
+ {
+ udstruct *uin, *uxref;
++ Dict *d;
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Object);
+ uxref = (udstruct *) luaL_checkudata(L, 2, M_XRef);
+ if (uin->pd != NULL && uxref->pd != NULL && uin->pd != uxref->pd)
+@@ -1476,7 +1472,8 @@
+ if ((uin->pd != NULL && uin->pd->pc != uin->pc)
+ || (uxref->pd != NULL && uxref->pd->pc != uxref->pc))
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initDict((XRef *) uxref->d);
++ d = new Dict((XRef *) uxref->d);
++ *((Object *) uin->d) = Object(d);
+ return 0;
+ }
+
+@@ -1490,7 +1487,7 @@
+ if ((uin->pd != NULL && uin->pd->pc != uin->pc)
+ || (ustream->pd != NULL && ustream->pd->pc != ustream->pc))
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initStream((Stream *) ustream->d);
++ *((Object *) uin->d) = Object((Stream *) ustream->d);
+ return 0;
+ }
+
+@@ -1503,7 +1500,7 @@
+ pdfdoc_changed_error(L);
+ num = luaL_checkint(L, 2);
+ gen = luaL_checkint(L, 3);
+- ((Object *) uin->d)->initRef(num, gen);
++ *((Object *) uin->d) = Object(num, gen);
+ return 0;
+ }
+
+@@ -1515,7 +1512,7 @@
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+ s = luaL_checkstring(L, 2);
+- ((Object *) uin->d)->initCmd(CHARP_CAST s);
++ *((Object *) uin->d) = Object(objCmd, CHARP_CAST s);
+ return 0;
+ }
+
+@@ -1525,7 +1522,7 @@
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Object);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initError();
++ *((Object *) uin->d) = Object(objError);
+ return 0;
+ }
+
+@@ -1535,7 +1532,7 @@
+ uin = (udstruct *) luaL_checkudata(L, 1, M_Object);
+ if (uin->pd != NULL && uin->pd->pc != uin->pc)
+ pdfdoc_changed_error(L);
+- ((Object *) uin->d)->initEOF();
++ *((Object *) uin->d) = Object(objEOF);
+ return 0;
+ }
+
+@@ -1551,7 +1548,7 @@
+ pdfdoc_changed_error(L);
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->fetch((XRef *) uxref->d, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->fetch((XRef *) uxref->d);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1816,7 +1813,7 @@
+ pdfdoc_changed_error(L);
+ if (!((Object *) uin->d)->isArray())
+ luaL_error(L, "Object is not an Array");
+- ((Object *) uin->d)->arrayAdd((Object *) uobj->d);
++ ((Object *) uin->d)->arrayAdd(std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -1833,7 +1830,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->arrayGet(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->arrayGet(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1857,7 +1854,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->arrayGetNF(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->arrayGetNF(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1897,7 +1894,7 @@
+ pdfdoc_changed_error(L);
+ if (!((Object *) uin->d)->isDict())
+ luaL_error(L, "Object is not a Dict");
+- ((Object *) uin->d)->dictAdd(copyString(s), (Object *) uobj->d);
++ ((Object *) uin->d)->dictAdd(copyString(s), std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -1915,7 +1912,7 @@
+ pdfdoc_changed_error(L);
+ if (!((Object *) uin->d)->isDict())
+ luaL_error(L, "Object is not a Dict");
+- ((Object *) uin->d)->dictSet(s, (Object *) uobj->d);
++ ((Object *) uin->d)->dictSet(s, std::move(*((Object *) uobj->d)));
+ return 0;
+ }
+
+@@ -1930,7 +1927,7 @@
+ if (((Object *) uin->d)->isDict()) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->dictLookup(s, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->dictLookup(s);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1950,7 +1947,7 @@
+ if (((Object *) uin->d)->isDict()) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->dictLookupNF(s, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->dictLookupNF(s);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -1991,7 +1988,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->dictGetVal(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->dictGetVal(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -2015,7 +2012,7 @@
+ if (i > 0 && i <= len) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((Object *) uin->d)->dictGetValNF(i - 1, (Object *) uout->d);
++ *((Object *) uout->d) = ((Object *) uin->d)->dictGetValNF(i - 1);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -2243,7 +2240,7 @@
+ m_poppler_get_poppler(Page, Dict, getPieceInfo);
+ m_poppler_get_poppler(Page, Dict, getSeparationInfo);
+ m_poppler_get_poppler(Page, Dict, getResourceDict);
+-m_poppler_get_OBJECT(Page, getAnnots);
++m_poppler_get_OBJECT(Page, getAnnotsObject);
+
+ m_poppler_get_OBJECT(Page, getContents);
+
+@@ -2270,7 +2267,7 @@
+ {"getPieceInfo", m_Page_getPieceInfo},
+ {"getSeparationInfo", m_Page_getSeparationInfo},
+ {"getResourceDict", m_Page_getResourceDict},
+- {"getAnnots", m_Page_getAnnots},
++ {"getAnnots", m_Page_getAnnotsObject},
+ {"getContents", m_Page_getContents},
+ {"__tostring", m_Page__tostring},
+ {NULL, NULL} // sentinel
+@@ -2520,7 +2517,7 @@
+ if (((PdfDocument *) uin->d)->doc->getXRef()->isOk()) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((PdfDocument *) uin->d)->doc->getDocInfo((Object *) uout->d);
++ *((Object *) uout->d) = ((PdfDocument *) uin->d)->doc->getDocInfo();
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -2538,7 +2535,7 @@
+ if (((PdfDocument *) uin->d)->doc->getXRef()->isOk()) {
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((PdfDocument *) uin->d)->doc->getDocInfoNF((Object *) uout->d);
++ *((Object *) uout->d) = ((PdfDocument *) uin->d)->doc->getDocInfoNF();
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -2841,7 +2838,7 @@
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+ origin = (Object *) (((Attribute *) uin->d)->getValue());
+- origin->copy ( ((Object *)uout->d) );
++ *((Object *) uout->d) = origin->copy();
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -3320,7 +3317,7 @@
+ parent = root->findParentElement(i-1);
+ if (parent != NULL) {
+ uout = new_StructElement_userdata(L);
+- uout->d = new StructElement( *parent );
++ uout->d = (StructElement *) parent;
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+@@ -3370,7 +3367,7 @@
+ gen = luaL_checkint(L, 3);
+ uout = new_Object_userdata(L);
+ uout->d = new Object();
+- ((XRef *) uin->d)->fetch(num, gen, (Object *) uout->d);
++ *((Object *) uout->d) = ((XRef *) uin->d)->fetch(num, gen);
+ uout->atype = ALLOC_LEPDF;
+ uout->pc = uin->pc;
+ uout->pd = uin->pd;
+diff -ur source.orig/texk/web2c/luatexdir/lua/lpdfscannerlib.cc source/texk/web2c/luatexdir/lua/lpdfscannerlib.cc
+--- source.orig/texk/web2c/luatexdir/lua/lpdfscannerlib.cc 2017-05-08 22:39:36.692708395 +0200
++++ source/texk/web2c/luatexdir/lua/lpdfscannerlib.cc 2017-09-19 09:48:19.658021769 +0200
+@@ -634,7 +634,7 @@
+ int i;
+ for (i=0;i<count;i++) {
+ Object *val = new Object();
+- arrayref->get(i, val);
++ *val = arrayref->get(i);
+ if (val->isStream()) {
+ ObjectList *rover = self->_streams;
+ ObjectList *item = (ObjectList *)priv_xmalloc (sizeof(ObjectList));
+diff -ur source.orig/texk/web2c/pdftexdir/pdftoepdf.cc source/texk/web2c/pdftexdir/pdftoepdf.cc
+--- source.orig/texk/web2c/pdftexdir/pdftoepdf.cc 2017-06-16 21:49:09.293857387 +0200
++++ source/texk/web2c/pdftexdir/pdftoepdf.cc 2017-09-19 09:48:19.661355046 +0200
+@@ -84,31 +84,6 @@
+ #define MASK_SUPPRESS_PTEX_PAGENUMBER 0x04
+ #define MASK_SUPPRESS_PTEX_INFODICT 0x08
+
+-// PdfObject encapsulates the xpdf Object type,
+-// and properly frees its resources on destruction.
+-// Use obj-> to access members of the Object,
+-// and &obj to get a pointer to the object.
+-// It is no longer necessary to call Object::free explicitely.
+-
+-class PdfObject {
+- public:
+- PdfObject() { // nothing
+- } ~PdfObject() {
+- iObject.free();
+- }
+- Object *operator->() {
+- return &iObject;
+- }
+- Object *operator&() {
+- return &iObject;
+- }
+- private: // no copying or assigning
+- PdfObject(const PdfObject &);
+- void operator=(const PdfObject &);
+- public:
+- Object iObject;
+-};
+-
+ // When copying the Resources of the selected page, all objects are copied
+ // recusively top-down. Indirect objects however are not fetched during
+ // copying, but get a new object number from pdfTeX and then will be
+@@ -212,18 +187,6 @@
+ delete pdf_doc;
+ }
+
+-// Replacement for
+-// Object *initDict(Dict *dict1){ initObj(objDict); dict = dict1; return this; }
+-
+-static void initDictFromDict(PdfObject & obj, Dict * dict)
+-{
+- obj->initDict(xref);
+- for (int i = 0, l = dict->getLength(); i < l; i++) {
+- Object obj1;
+- obj->dictAdd(copyString(dict->getKey(i)), dict->getValNF(i, &obj1));
+- }
+-}
+-
+ // --------------------------------------------------------------------
+
+ static int addEncoding(GfxFont * gfont)
+@@ -320,10 +283,10 @@
+
+ static void copyDictEntry(Object * obj, int i)
+ {
+- PdfObject obj1;
++ Object obj1;
+ copyName(obj->dictGetKey(i));
+ pdf_puts(" ");
+- obj->dictGetValNF(i, &obj1);
++ obj1 = obj->dictGetValNF(i);
+ copyObject(&obj1);
+ pdf_puts("\n");
+ }
+@@ -376,17 +339,17 @@
+ static void copyProcSet(Object * obj)
+ {
+ int i, l;
+- PdfObject procset;
++ Object procset;
+ if (!obj->isArray())
+ pdftex_fail("PDF inclusion: invalid ProcSet array type <%s>",
+ obj->getTypeName());
+ pdf_puts("/ProcSet [ ");
+ for (i = 0, l = obj->arrayGetLength(); i < l; ++i) {
+- obj->arrayGetNF(i, &procset);
+- if (!procset->isName())
++ procset = obj->arrayGetNF(i);
++ if (!procset.isName())
+ pdftex_fail("PDF inclusion: invalid ProcSet entry type <%s>",
+- procset->getTypeName());
+- copyName(procset->getName());
++ procset.getTypeName());
++ copyName(procset.getName());
+ pdf_puts(" ");
+ }
+ pdf_puts("]\n");
+@@ -394,10 +357,29 @@
+
+ #define REPLACE_TYPE1C true
+
++static bool embeddableFont(Object * fontdesc)
++{
++ Object fontfile, ffsubtype;
++
++ if (!fontdesc->isDict())
++ return false;
++ fontfile = fontdesc->dictLookup("FontFile");
++ if (fontfile.isStream())
++ return true;
++ if (REPLACE_TYPE1C) {
++ fontfile = fontdesc->dictLookup("FontFile3");
++ if (!fontfile.isStream())
++ return false;
++ ffsubtype = fontfile.streamGetDict()->lookup("Subtype");
++ return ffsubtype.isName() && !strcmp(ffsubtype.getName(), "Type1C");
++ }
++ return false;
++}
++
+ static void copyFont(char *tag, Object * fontRef)
+ {
+- PdfObject fontdict, subtype, basefont, fontdescRef, fontdesc, charset,
+- fontfile, ffsubtype, stemV;
++ Object fontdict, subtype, basefont, fontdescRef, fontdesc, charset,
++ stemV;
+ GfxFont *gfont;
+ fd_entry *fd;
+ fm_entry *fontmap;
+@@ -413,33 +395,39 @@
+ }
+ // Only handle included Type1 (and Type1C) fonts; anything else will be copied.
+ // Type1C fonts are replaced by Type1 fonts, if REPLACE_TYPE1C is true.
+- if (!fixedinclusioncopyfont && fontRef->fetch(xref, &fontdict)->isDict()
+- && fontdict->dictLookup("Subtype", &subtype)->isName()
+- && !strcmp(subtype->getName(), "Type1")
+- && fontdict->dictLookup("BaseFont", &basefont)->isName()
+- && fontdict->dictLookupNF("FontDescriptor", &fontdescRef)->isRef()
+- && fontdescRef->fetch(xref, &fontdesc)->isDict()
+- && (fontdesc->dictLookup("FontFile", &fontfile)->isStream()
+- || (REPLACE_TYPE1C
+- && fontdesc->dictLookup("FontFile3", &fontfile)->isStream()
+- && fontfile->streamGetDict()->lookup("Subtype",
+- &ffsubtype)->isName()
+- && !strcmp(ffsubtype->getName(), "Type1C")))
+- && (fontmap = lookup_fontmap(basefont->getName())) != NULL) {
++ fontdict = fontRef->fetch(xref);
++ fontdesc = Object(objNull);
++ if (fontdict.isDict()) {
++ subtype = fontdict.dictLookup("Subtype");
++ basefont = fontdict.dictLookup("BaseFont");
++ fontdescRef = fontdict.dictLookupNF("FontDescriptor");
++ if (fontdescRef.isRef()) {
++ fontdesc = fontdescRef.fetch(xref);
++ }
++ }
++ if (!fixedinclusioncopyfont && fontdict.isDict()
++ && subtype.isName()
++ && !strcmp(subtype.getName(), "Type1")
++ && basefont.isName()
++ && fontdescRef.isRef()
++ && fontdesc.isDict()
++ && embeddableFont(&fontdesc)
++ && (fontmap = lookup_fontmap(basefont.getName())) != NULL) {
+ // round /StemV value, since the PDF input is a float
+ // (see Font Descriptors in PDF reference), but we only store an
+ // integer, since we don't want to change the struct.
+- fontdesc->dictLookup("StemV", &stemV);
+- fd = epdf_create_fontdescriptor(fontmap, zround(stemV->getNum()));
+- if (fontdesc->dictLookup("CharSet", &charset) &&
+- charset->isString() && is_subsetable(fontmap))
+- epdf_mark_glyphs(fd, charset->getString()->getCString());
++ stemV = fontdesc.dictLookup("StemV");
++ fd = epdf_create_fontdescriptor(fontmap, zround(stemV.getNum()));
++ charset = fontdesc.dictLookup("CharSet");
++ if (!charset.isNull() &&
++ charset.isString() && is_subsetable(fontmap))
++ epdf_mark_glyphs(fd, charset.getString()->getCString());
+ else
+ embed_whole_font(fd);
+- addFontDesc(fontdescRef->getRef(), fd);
++ addFontDesc(fontdescRef.getRef(), fd);
+ copyName(tag);
+ gfont = GfxFont::makeFont(xref, tag, fontRef->getRef(),
+- fontdict->getDict());
++ fontdict.getDict());
+ pdf_printf(" %d 0 R ", addFont(fontRef->getRef(), fd,
+ addEncoding(gfont)));
+ } else {
+@@ -451,24 +439,24 @@
+
+ static void copyFontResources(Object * obj)
+ {
+- PdfObject fontRef;
++ Object fontRef;
+ int i, l;
+ if (!obj->isDict())
+ pdftex_fail("PDF inclusion: invalid font resources dict type <%s>",
+ obj->getTypeName());
+ pdf_puts("/Font << ");
+ for (i = 0, l = obj->dictGetLength(); i < l; ++i) {
+- obj->dictGetValNF(i, &fontRef);
+- if (fontRef->isRef())
++ fontRef = obj->dictGetValNF(i);
++ if (fontRef.isRef())
+ copyFont(obj->dictGetKey(i), &fontRef);
+- else if (fontRef->isDict()) { // some programs generate pdf with embedded font object
++ else if (fontRef.isDict()) { // some programs generate pdf with embedded font object
+ copyName(obj->dictGetKey(i));
+ pdf_puts(" ");
+ copyObject(&fontRef);
+ }
+ else
+ pdftex_fail("PDF inclusion: invalid font in reference type <%s>",
+- fontRef->getTypeName());
++ fontRef.getTypeName());
+ }
+ pdf_puts(">>\n");
+ }
+@@ -557,7 +545,7 @@
+
+ static void copyObject(Object * obj)
+ {
+- PdfObject obj1;
++ Object obj1;
+ int i, l, c;
+ Ref ref;
+ char *p;
+@@ -601,8 +589,8 @@
+ } else if (obj->isArray()) {
+ pdf_puts("[");
+ for (i = 0, l = obj->arrayGetLength(); i < l; ++i) {
+- obj->arrayGetNF(i, &obj1);
+- if (!obj1->isName())
++ obj1 = obj->arrayGetNF(i);
++ if (!obj1.isName())
+ pdf_puts(" ");
+ copyObject(&obj1);
+ }
+@@ -612,9 +600,8 @@
+ copyDict(obj);
+ pdf_puts(">>");
+ } else if (obj->isStream()) {
+- initDictFromDict(obj1, obj->streamGetDict());
+ pdf_puts("<<\n");
+- copyDict(&obj1);
++ copyDict(obj->getStream()->getDictObject());
+ pdf_puts(">>\n");
+ pdf_puts("stream\n");
+ copyStream(obj->getStream()->getUndecodedStream());
+@@ -638,9 +625,8 @@
+ InObj *r;
+ for (r = inObjList; r != 0; r = r->next) {
+ if (!r->written) {
+- Object obj1;
+ r->written = 1;
+- xref->fetch(r->ref.num, r->ref.gen, &obj1);
++ Object obj1 = xref->fetch(r->ref.num, r->ref.gen);
+ if (r->type == objFont) {
+ assert(!obj1.isStream());
+ pdfbeginobj(r->num, 2); // \pdfobjcompresslevel = 2 is for this
+@@ -656,7 +642,6 @@
+ pdf_puts("\n");
+ pdfendobj();
+ }
+- obj1.free();
+ }
+ }
+ }
+@@ -839,8 +824,8 @@
+ Page *page;
+ Ref *pageRef;
+ Dict *pageDict;
+- PdfObject contents, obj1, obj2, pageObj, dictObj;
+- PdfObject groupDict;
++ Object contents, obj1, obj2, pageObj, dictObj;
++ Object groupDict;
+ bool writeSepGroup = false;
+ Object info;
+ char *key;
+@@ -867,8 +852,8 @@
+ encodingList = 0;
+ page = pdf_doc->doc->getCatalog()->getPage(epdf_selected_page);
+ pageRef = pdf_doc->doc->getCatalog()->getPageRef(epdf_selected_page);
+- xref->fetch(pageRef->num, pageRef->gen, &pageObj);
+- pageDict = pageObj->getDict();
++ pageObj = xref->fetch(pageRef->num, pageRef->gen);
++ pageDict = pageObj.getDict();
+ rotate = page->getRotate();
+ PDFRectangle *pagebox;
+ // write the Page header
+@@ -886,7 +871,7 @@
+ pdf_printf("/%s.PageNumber %i\n", pdfkeyprefix, (int) epdf_selected_page);
+ }
+ if ((suppress_ptex_info & MASK_SUPPRESS_PTEX_INFODICT) == 0) {
+- pdf_doc->doc->getDocInfoNF(&info);
++ info = pdf_doc->doc->getDocInfoNF();
+ if (info.isRef()) {
+ // the info dict must be indirect (PDF Ref p. 61)
+ pdf_printf("/%s.InfoDict ", pdfkeyprefix);
+@@ -942,14 +927,14 @@
+ pdf_puts(stripzeros(s));
+
+ // Metadata validity check (as a stream it must be indirect)
+- pageDict->lookupNF("Metadata", &dictObj);
+- if (!dictObj->isNull() && !dictObj->isRef())
++ dictObj = pageDict->lookupNF("Metadata");
++ if (!dictObj.isNull() && !dictObj.isRef())
+ pdftex_warn("PDF inclusion: /Metadata must be indirect object");
+
+ // copy selected items in Page dictionary except Resources & Group
+ for (i = 0; pageDictKeys[i] != NULL; i++) {
+- pageDict->lookupNF(pageDictKeys[i], &dictObj);
+- if (!dictObj->isNull()) {
++ dictObj = pageDict->lookupNF(pageDictKeys[i]);
++ if (!dictObj.isNull()) {
+ pdf_newline();
+ pdf_printf("/%s ", pageDictKeys[i]);
+ copyObject(&dictObj); // preserves indirection
+@@ -957,8 +942,8 @@
+ }
+
+ // handle page group
+- pageDict->lookupNF("Group", &dictObj);
+- if (!dictObj->isNull()) {
++ dictObj = pageDict->lookupNF("Group");
++ if (!dictObj.isNull()) {
+ if (pdfpagegroupval == 0) {
+ // another pdf with page group was included earlier on the
+ // same page; copy the Group entry as is. See manual for
+@@ -972,11 +957,11 @@
+ copyObject(&dictObj);
+ } else {
+ // write Group dict as a separate object, since the Page dict also refers to it
+- pageDict->lookup("Group", &dictObj);
+- if (!dictObj->isDict())
++ dictObj = pageDict->lookup("Group");
++ if (!dictObj.isDict())
+ pdftex_fail("PDF inclusion: /Group dict missing");
+ writeSepGroup = true;
+- initDictFromDict(groupDict, page->getGroup());
++ groupDict = Object(page->getGroup());
+ pdf_printf("/Group %ld 0 R\n", (long)pdfpagegroupval);
+ }
+ }
+@@ -989,14 +974,14 @@
+ pdftex_warn
+ ("PDF inclusion: /Resources missing. 'This practice is not recommended' (PDF Ref)");
+ } else {
+- initDictFromDict(obj1, page->getResourceDict());
++ Object *obj1 = page->getResourceDictObject();
+ if (!obj1->isDict())
+ pdftex_fail("PDF inclusion: invalid resources dict type <%s>",
+ obj1->getTypeName());
+ pdf_newline();
+ pdf_puts("/Resources <<\n");
+ for (i = 0, l = obj1->dictGetLength(); i < l; ++i) {
+- obj1->dictGetVal(i, &obj2);
++ obj2 = obj1->dictGetVal(i);
+ key = obj1->dictGetKey(i);
+ if (strcmp("Font", key) == 0)
+ copyFontResources(&obj2);
+@@ -1009,8 +994,8 @@
+ }
+
+ // write the page contents
+- page->getContents(&contents);
+- if (contents->isStream()) {
++ contents = page->getContents();
++ if (contents.isStream()) {
+
+ // Variant A: get stream and recompress under control
+ // of \pdfcompresslevel
+@@ -1021,36 +1006,35 @@
+
+ // Variant B: copy stream without recompressing
+ //
+- contents->streamGetDict()->lookup("F", &obj1);
+- if (!obj1->isNull()) {
++ obj1 = contents.streamGetDict()->lookup("F");
++ if (!obj1.isNull()) {
+ pdftex_fail("PDF inclusion: Unsupported external stream");
+ }
+- contents->streamGetDict()->lookup("Length", &obj1);
+- assert(!obj1->isNull());
++ obj1 = contents.streamGetDict()->lookup("Length");
++ assert(!obj1.isNull());
+ pdf_puts("/Length ");
+ copyObject(&obj1);
+ pdf_puts("\n");
+- contents->streamGetDict()->lookup("Filter", &obj1);
+- if (!obj1->isNull()) {
++ obj1 = contents.streamGetDict()->lookup("Filter");
++ if (!obj1.isNull()) {
+ pdf_puts("/Filter ");
+ copyObject(&obj1);
+ pdf_puts("\n");
+- contents->streamGetDict()->lookup("DecodeParms", &obj1);
+- if (!obj1->isNull()) {
++ obj1 = contents.streamGetDict()->lookup("DecodeParms");
++ if (!obj1.isNull()) {
+ pdf_puts("/DecodeParms ");
+ copyObject(&obj1);
+ pdf_puts("\n");
+ }
+ }
+ pdf_puts(">>\nstream\n");
+- copyStream(contents->getStream()->getUndecodedStream());
++ copyStream(contents.getStream()->getUndecodedStream());
+ pdfendstream();
+- } else if (contents->isArray()) {
++ } else if (contents.isArray()) {
+ pdfbeginstream();
+- for (i = 0, l = contents->arrayGetLength(); i < l; ++i) {
+- Object contentsobj;
+- copyStream((contents->arrayGet(i, &contentsobj))->getStream());
+- contentsobj.free();
++ for (i = 0, l = contents.arrayGetLength(); i < l; ++i) {
++ Object contentsobj = contents.arrayGet(i);
++ copyStream(contentsobj.getStream());
+ if (i < l - 1)
+ pdf_newline(); // add a newline after each stream except the last
+ }
+diff -ur source.orig/texk/web2c/pdftexdir/pdftosrc.cc source/texk/web2c/pdftexdir/pdftosrc.cc
+--- source.orig/texk/web2c/pdftexdir/pdftosrc.cc 2017-06-16 21:49:09.297190679 +0200
++++ source/texk/web2c/pdftexdir/pdftosrc.cc 2017-09-19 09:48:19.661355046 +0200
+@@ -86,22 +86,20 @@
+ objgen = atoi(argv[3]);
+ }
+ xref = doc->getXRef();
+- catalogDict.initNull();
+- xref->getCatalog(&catalogDict);
++ catalogDict = xref->getCatalog();
+ if (!catalogDict.isDict("Catalog")) {
+ fprintf(stderr, "No Catalog found\n");
+ exit(1);
+ }
+- srcStream.initNull();
++ srcStream = Object(objNull);
+ if (objnum == 0) {
+- catalogDict.dictLookup("SourceObject", &srcStream);
++ srcStream = catalogDict.dictLookup("SourceObject");
+ static char const_SourceFile[] = "SourceFile";
+ if (!srcStream.isStream(const_SourceFile)) {
+ fprintf(stderr, "No SourceObject found\n");
+ exit(1);
+ }
+- srcName.initNull();
+- srcStream.getStream()->getDict()->lookup("SourceName", &srcName);
++ srcName = srcStream.getStream()->getDict()->lookup("SourceName");
+ if (!srcName.isString()) {
+ fprintf(stderr, "No SourceName found\n");
+ exit(1);
+@@ -110,7 +108,7 @@
+ // We cannot free srcName, as objname shares its string.
+ // srcName.free();
+ } else if (objnum > 0) {
+- xref->fetch(objnum, objgen, &srcStream);
++ srcStream = xref->fetch(objnum, objgen);
+ if (!srcStream.isStream()) {
+ fprintf(stderr, "Not a Stream object\n");
+ exit(1);
+@@ -159,29 +157,26 @@
+ int localOffset = 0;
+ Guint firstOffset;
+
+- assert(xref->fetch(e->offset, 0, &objStr)->isStream());
+- nObjects = objStr.streamGetDict()->lookup("N", &obj1)->getInt();
+- obj1.free();
+- first = objStr.streamGetDict()->lookup("First", &obj1)->getInt();
+- obj1.free();
++ objStr = xref->fetch(e->offset, 0);
++ assert(objStr.isStream());
++ obj1 = objStr.streamGetDict()->lookup("N");
++ nObjects = obj1.getInt();
++ obj1 = objStr.streamGetDict()->lookup("First");
++ first = obj1.getInt();
+ firstOffset = objStr.getStream()->getBaseStream()->getStart() + first;
+
+ // parse the header: object numbers and offsets
+ objStr.streamReset();
+- obj1.initNull();
+- str = new EmbedStream(objStr.getStream(), &obj1, gTrue, first);
++ str = new EmbedStream(objStr.getStream(), Object(objNull), gTrue, first);
+ parser = new Parser(xref, new Lexer(xref, str), gFalse);
+ for (n = 0; n < nObjects; ++n) {
+- parser->getObj(&obj1);
+- parser->getObj(&obj2);
++ obj1 = parser->getObj();
++ obj2 = parser->getObj();
+ if (n == e->gen)
+ localOffset = obj2.getInt();
+- obj1.free();
+- obj2.free();
+ }
+ while (str->getChar() != EOF) ;
+ delete parser;
+- objStr.free();
+
+ fprintf(outfile, "%.10lu 00000 n\n",
+ (long unsigned)(firstOffset + localOffset));
+@@ -192,7 +187,6 @@
+ s->reset();
+ while ((c = s->getChar()) != EOF)
+ fputc(c, outfile);
+- srcStream.free();
+ }
+ if (objnum == 0)
+ fprintf(stderr, "Source file extracted to %s\n", outname);
+@@ -201,7 +195,6 @@
+ else
+ fprintf(stderr, "Cross-reference table extracted to %s\n", outname);
+ fclose(outfile);
+- catalogDict.free();
+ delete doc;
+ delete globalParams;
+ }
diff --git a/office/texlive/prep/dump.unused.internal.libraries.from.sources.sh b/office/texlive/prep/dump.unused.internal.libraries.from.sources.sh
new file mode 100644
index 0000000000..71ab0b53db
--- /dev/null
+++ b/office/texlive/prep/dump.unused.internal.libraries.from.sources.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+# Repacks the texlive tarball to remove unused sources.
+
+VERSION=${VERSION:-$(echo texlive-*source.tar.?z* | rev | cut -f 2 -d - | cut -f 1 -d - | rev)}
+
+tar xf texlive-${VERSION}-source.tar.xz || exit 1
+mv texlive-${VERSION}-source.tar.xz texlive-${VERSION}-source.tar.xz.orig
+( cd texlive-${VERSION}-source/libs && rm -rf cairo freetype2 gd gmp mpfr icu libpng pixman zlib )
+( cd texlive-${VERSION}-source/utils && rm -rf asymptote )
+tar cf texlive-${VERSION}-source.tar texlive-${VERSION}-source
+rm -r texlive-${VERSION}-source
+#xz -9 texlive-${VERSION}-source.tar
+xz texlive-${VERSION}-source.tar
+touch -r texlive-${VERSION}-source.tar.xz.orig texlive-${VERSION}-source.tar.xz
+rm texlive-${VERSION}-source.tar.xz.orig
diff --git a/office/texlive/prep/texmf_get.sh b/office/texlive/prep/texmf_get.sh
index 34122ab5f2..045b570224 100644
--- a/office/texlive/prep/texmf_get.sh
+++ b/office/texlive/prep/texmf_get.sh
@@ -1,6 +1,6 @@
#!/bin/bash
-# texmf_get.sh (c) 2016-2017 Johannes Schoepfer, slackbuilds[at]schoepfer[dot]info
+# texmf_get.sh (c) 2016-2017 Johannes Schoepfer, Germany, slackbuilds[at]schoepfer[dot]info
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -20,7 +20,7 @@
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
-# V 0.7
+# V 0.9
#
# Prepare xz-compressed tarballs of texlive-texmf-trees based on texlive.tlpdb
# This script takes care of dependencies(as far as these are present in texlive.tlpdb) of collections and packages,
@@ -53,7 +53,6 @@ packages () {
cm-super
cbfonts
sanskrit-t1
- cmcyr
uhc
fonts-tlwg
ethiop-t1
@@ -61,14 +60,30 @@ packages () {
wadalab
fandol
arphic
- nanumtype1" \
- texmfget fonts
+ mxedruli
+ skaknew
+ padauk
+ japanese-otf
+ musixtex-fonts
+ unfonts-extra
+ baekmuk
+ arphic-ttf
+ unfonts-core
+ nanumtype1
+ " texmfget fonts
+
+# put some stuff in "extra" to before it makes its way into base
+PACKAGES="
+ arara
+ latex2nemeth
+ montex
+ " \
+ texmfget extra
# The base. some notes:
# cs needed by fmtutil-sys --all, 2017-06-24
-# hyphen-belarusian needed by fmtutil-sys --all, 2017-06-24
-# hyphen-ethiopic
PACKAGES="
+ $(cat $TMP/corepackages)
collection-basic
collection-latex
collection-latexrecommended
@@ -81,7 +96,7 @@ packages () {
collection-context
collection-mathscience
collection-plaingeneric
- lh
+ collection-binextra
yfonts
doublestroke
was
@@ -102,7 +117,6 @@ packages () {
titlesec
siunitx
combelow
- csplain
csquotes
etoolbox
etextools
@@ -111,46 +125,27 @@ packages () {
idxlayout
bidi
filecontents
- cs
+ eplain
+ texsis
+ mltex
+ lollipop
+ moreverb
+ collection-langcyrillic
collection-langeuropean
collection-langenglish
collection-langfrench
collection-langgerman
+ collection-langgreek
collection-langitalian
collection-langpolish
collection-langportuguese
collection-langspanish
- collection-langgreek
- hyphen-belarusian
- hyphen-ethiopic
- hyphen-czech
- hyphen-slovak
- hyphen-indic
- hyphen-sanskrit
- hyphen-armenian
- hyphen-afrikaans
- hyphen-esperanto
- hyphen-bulgarian
- hyphen-churchslavonic
- hyphen-mongolian
- hyphen-russian
- hyphen-serbian
- hyphen-ukrainian
- hyphen-catalan
- hyphen-galician
- hyphen-chinese
- hyphen-coptic
- hyphen-georgian
- hyphen-indonesian
- hyphen-interlingua
- hyphen-thai
- hyphen-turkmen
- hyphen-arabic
- hyphen-farsi" \
- texmfget base
+ " texmfget base
# Call "fonts"-tarball again to add remaining fonts
-PACKAGES="collection-fontsextra" texmfget fonts
+PACKAGES="
+ collection-fontsextra
+ " texmfget fonts
# Put all remaining stuff in the "extra" tarball
PACKAGES="
@@ -162,18 +157,18 @@ PACKAGES="collection-fontsextra" texmfget fonts
collection-games
collection-publishers
collection-bibtexextra
- collection-binextra
collection-music
- collection-langother
collection-pstricks
- collection-langcyrillic
+ collection-texworks
+ collection-wintools
collection-langczechslovak
collection-langjapanese
collection-langkorean
collection-langarabic
collection-langchinese
- collection-langcjk" \
- texmfget extra
+ collection-langcjk
+ collection-langother
+ " texmfget extra
# The docs-tarball - very big (about 1300 MB)
texmfget docs
@@ -188,36 +183,6 @@ PACKAGES="collection-fontsextra" texmfget fonts
done < $TMP/allcollections
fi
-# Following collections are windows only related
-#NAME=texworks PACKAGES="collection-texworks" ./texmf_get.sh
-#NAME=wintools PACKAGES="collection-wintools" ./texmf_get.sh
-
-# For the records:
-#
-# base-tarball:
-# hyphen-packages are for "fmtutil-sys -all" to proceed without errors
-#
-# for building dblatex:
-# appendix
-# changebar
-# footmisc
-# multirow
-# overpic
-# stmaryrd
-# subfigure
-# titlesec
-
-# for math masters thesis
-# doublestroke
-# was
-
-# decided these are commonly useful and not too big, or or small to just have it for wider support of the base-package
-# csplain
-# yfonts
-
-# to make biber functional
-# biblatex
-
}
# ==== Nothing to edit beyond this line (hopefully) ====
@@ -228,7 +193,6 @@ usage () {
exit
}
-
package_meta () {
echo "collection/package $collection"
# collection start linenumer
@@ -249,6 +213,10 @@ package_meta () {
}
package_list () {
+
+# Remove outputfile if already present
+[ -s "$output" ] && rm $output
+
# Only do something if $collection wasn't already done before
while [ -s $collections_tobedone ]
do
@@ -271,7 +239,7 @@ do
package_meta
fi
- # ignore dependend collections generally, as this adds far too much and therefore reduces controll over what packages to be added
+ # Don't handle collections as dependency of other collections, as this adds far too much and therefore reduces controll over what packages to be added
sed -i "/^depend collection/d" $tmpfile
# If $collection is a singel package, add it here
if [ -n "$(head -n1 $tmpfile | fgrep -v "name collection" )" ]
@@ -294,8 +262,8 @@ done
}
untar () {
- # download packages, if not already available. Not for all packages a corresponding .doc package exists
- rm $1.meta
+ # Download packages, if not already available. Not every packages has a corresponding .doc package.
+ [ -f $output.meta ] && rm $output.meta
while read package
do
# untar all packages, check for relocation, "relocate 1" -> untar in texmf-dist
@@ -331,7 +299,7 @@ untar () {
exit 1
fi
- # exclude the tlpkg-stuff, TLUtils.pm(needed tu run texlive) comes from source installation
+ # Exclude the tlpkg-stuff, TLUtils.pm(needed tu run texlive) is provided by texlive-source
grep -w ^"relocated 1" $texmf/$package.meta &>/dev/null
if [ $? = 0 ]
then
@@ -339,7 +307,7 @@ untar () {
else
tar vxf ${package}${flavour}.tar.xz --exclude tlpkg || exit 1
fi
- # in case a binary package was decompressed, put it in texmf-dist
+ # In case a binary package was decompressed, put it in texmf-dist
[ -d bin ] && cp -a bin texmf-dist && rm -rf bin
if [ "$flavour" = ".doc" ]
then
@@ -348,17 +316,17 @@ untar () {
size=$(( $(grep ^containersize $texmf/$package.meta | cut -d' ' -f2 ) / 1024 ))
fi
shortdesc="$(grep ^shortdesc $texmf/$package.meta | cut -d' ' -f2- )"
- echo "$size Kb, $package: $shortdesc" >> $1.meta
+ echo "$size Kb, $package: $shortdesc" >> $output.meta
done < $1
- # copy packages-list to texmf-dist, so included packages are known in later installation
- sort -n $1.meta > TMPFILE
- mv TMPFILE $1.meta
- cp $1.meta texmf-dist/
+ # Copy packages-list to texmf-dist, so included packages are known in later installation
+ sort -n $output.meta > $output.meta.$TARBALL
+ cp $output.meta.$TARBALL texmf-dist/
+ rm $output.meta
}
remove_cruft () {
- # Remove m$-stuff, ConTeXt single-user-system stuff, KOMA-Script sources and pdf-manpages
+ # Remove m$-stuff, ConTeXt single-user-system stuff, source leftovers and pdf-versions of manpages
rm -rf texmf-dist/source
rm -rf texmf-dist/scripts/context/stubs/source/
find texmf-dist/ -type d -name 'win32' -exec rm -rf {} +
@@ -371,82 +339,49 @@ remove_cruft () {
find texmf-dist/ -type f -name '*win32*' -delete
find texmf-dist/ -type f -name 'winansi*' -delete
find texmf-dist/ -type f -name '*-man.pdf' -delete
- # remove zero-length files, as these appear e.g. in hyph-utf8 tex-package.
+ # Remove zero-length files, as these appear e.g. in hyph-utf8 tex-package.
find . -type f -size 0c -delete
}
texmfget () {
-NAME="$1"
-# remove outputfile if already present
-[ -s "$output" ] && rm $output
-
-# check all content to make sure no package is added more than once. Docs contain every docfile
+# Check all content to make sure no package is added more than once. Docs contain every docfile
if [ $TARBALL != docs ]
then
- echo "Preparing list of packages to be added the $NAME-tarball ..."
+ echo "Preparing list of packages to be added to ${1}-tarball ..."
echo "$PACKAGES" | sed "s/[[:space:]]//g;/^$/d" >> $collections_tobedone
package_list
fi
-if [ $NAME = $TARBALL ]
+# Process only the one named($1) tarball
+if [ "$1" = $TARBALL ]
then
cd $texmf
-# split packge
-#echo "Finding fonts which are present as metafont-source(.mf), move corresponding pfb to remainder-package. Be patient ..."
-##find . -type f -name '*.mf' | tee -a fontfiles
-#find texmf-dist -type f -name '*.mf' > fontfiles
-##sed -i -n "/amsfonts/!p" fontfiles
-#rev fontfiles | cut -d'.' -f2 | cut -d'/' -f1 | rev > fontnames
-#find texmf-dist -type f -name "*.pfb" > fonts.type1
-#find texmf-dist -type f -name "*.pfm" >> fonts.type1
-#find texmf-dist -type f -name "*.afm" >> fonts.type1
-#[ -f fonts.pfb ] && rm fonts.pfb
-#while read a
-#do
-# grep -w "$a.pfb" fonts.type1 >> fonts.pfb
-# grep -w "$a.pfm" fonts.type1 >> fonts.pfb
-# grep -w "$a.afm" fonts.type1 >> fonts.pfb
-# #find . -type f -name "$a.pfb" >> fonts.pfb
-# #find . -type f -name "$a.pfm" >> fonts.pfb
-# #find . -type f -name "$a.afm" >> fonts.pfb
-#done < fontnames
-#sort -u < fonts.pfb > $tmpfile
-#mv $tmpfile fonts.pfb
-##sed -i "/.*amsfonts.*/d" fonts.pfb
-## Only move cbfonts for now ...
-#sed -i -n "/cbfonts/p" fonts.pfb
-#rev fonts.pfb | cut -d'/' -f2- | rev > fontpathes
-##sort -u < fontpathes > $tmpfile
-##mv $tmpfile fontpathes
-#while read a; do mkdir -p remainder/$a; done < fontpathes
-#while read a; do mv $a remainder/$a; done < fonts.pfb
-#rm fontfiles fontnames fontpathes fonts.type1 fonts.pfb
-
-# cleanup tar-directory, just in case
+# Cleanup tar-directory, just in case
[ -d texmf-dist ] && rm -rf texmf-dist
-#unset flavour ; export flavour
mkdir texmf-dist &> /dev/null
+# Make tarball/checksum reproducible by setting mtime(clamp-mtime), owner, group and sort content
+# Doesn't work with tar 1.13, when makepkg creates the tarball:
+# tar-1.13: time_t value 9223372036854775808 too large (max=68719476735)
VERSION=$(cat $TMP/VERSION)
case $TARBALL in
docs)
export flavour=".doc"
untar $output_doc
remove_cruft
- tar vrf $TMP/texlive-$TARBALL-$VERSION.tar texmf-dist || exit 1
+ #tar vrf $TMP/texlive-$TARBALL-$VERSION.tar --clamp-mtime --mtime --owner=0 --group=0 --sort=name texmf-dist || exit 1
+ tar vrf $TMP/texlive-$TARBALL-$VERSION.tar --owner=0 --group=0 --sort=name texmf-dist || exit 1
echo "Packages-list: $output_doc"
rm -rf texmf-dist
;;
base|extra|fonts)
untar $output
remove_cruft
- tar vrf $TMP/texlive-$TARBALL-$VERSION.tar texmf-dist || exit 1
- cat $output.meta >> $output.meta.$TARBALL
- rm $output.meta
- rm $output
+ #tar vrf $TMP/texlive-$TARBALL-$VERSION.tar --clamp-mtime --mtime --owner=0 --group=0 --sort=name texmf-dist || exit 1
+ tar vrf $TMP/texlive-$TARBALL-$VERSION.tar --owner=0 --group=0 --sort=name texmf-dist || exit 1
rm -rf texmf-dist
;;
esac
@@ -465,15 +400,15 @@ esac
mkdir -p $texmf
cd $TMP
-# create run.tlpkg and doc.tlpkg only if $db.orig isn't there yet/was deleted
+# Create run.tlpkg and doc.tlpkg only if $db.orig isn't there yet/was deleted
if [ ! -s $TMP/${db}.orig -o ! -s $TMP/${db} ]
then
echo $MAJORVERSION.$(date +%y%m%d) > VERSION
wget -c -O $TMP/${db}.orig -c ${mirror}tlpkg/$db
# shrink db to be faster on later processing
- sed "/^ \+./d;/^longdesc \+./d;/^cat\+./d;/^rev\+./d;/^exe\+./d;/^bin\+./d;/^src\+./d" $TMP/${db}.orig > $TMP/$db
+ sed "/^ \+./d;/^longdesc \+./d;/^rev\+./d;/^exe\+./d;/^bin\+./d;/^src\+./d" $TMP/${db}.orig > $TMP/$db
- # as $db(might be) is new, remove the meta-files, be created again with pontentionally new content
+ # As $db (might be)is new, remove the meta-files, might created again with (pontentionally) new content
rm -rf $texmf/*.meta
rm $TMP/run.tlpkg
[ -f "$output_doc" ] && rm "$output_doc"
@@ -484,8 +419,11 @@ then
# Make a list of all collections
grep ^"name collection-" $TMP/$db | cut -d' ' -f2 > $TMP/allcollections
+
+ # Provide TLCore packages for the base-tarball, as these packages(and their dependencies) should be present in any case.
+ grep -B1 ^'category TLCore' $TMP/$db | grep -v ^'category TLCore' | grep -v ^-- | grep -v '\.' | cut -d' ' -f2 > $TMP/corepackages
- # add biber (perl)binaries as special exception.
+ # add biber (perl)binaries as special exception as it is not fun to build
cat <<- EOF >> $TMP/allpackages
biber.x86_64-linux
biber.i386-linux
@@ -496,57 +434,26 @@ fi
# globaly excluded packages, which does not make sense without tlpkg-installer, or are non-linux specific, or are already covered by the sourcebuild,
# or are covered by an external package(asymptote), or obsolete packages(datetime replaced by datetime2, anysize replaced by geometry)
-global_exclude="
-"
-# currently unused variable, to be considered if these are already included by the source-tarball, or strip these of the source-tarball and add them as texlive-package?
-zglobal_exclude="
-bibtex8
-bibtexu
-chktex
-cjkutils
-detex
-dtl
-dvi2tty
-dvidvi
-dviljk
-dvipdfmx
-dvipng
-dvipos
-dvisvgm
-gsftopk
-pdftools
-synctex
-texconfig
-texlive-docindex
-texlive-msg-translations
-texlive-scripts
-texworks
-
-l3kernel
-l3packages
-l3experimental
-fontspec
-ocgx
-luatex
-"
-
-for i in $global_exclude
+cat << EOF > $TMP/global_exclude
+tlcockpit
+tlshell
+texosquery
+asymptote
+asymptote-by-example-zh-cn
+asymptote-faq-zh-cn
+asymptote-manual-zh-cn
+EOF
+
+while read exlude
do
- if [ -z "$(grep -w ^"$i"$ $TMP/allpackages)" ]
- then
- echo "\"$i\" seems not to be a tex-package listet in $db, edit the"
- echo "global_exclude variable in this script, bye."
- exit 1
- else
- sed -i "/^${i}$/d" $TMP/allpackages
- [ -s $TMP/run.tlpkg ] && sed -i "/^${i}$/d" $TMP/run.tlpkg
- [ -s $output_doc ] && sed -i "/^${i}$/d" $output_doc
- fi
-done
+ sed -i "/^${i}$/d" $TMP/allpackages
+ [ -s $TMP/run.tlpkg ] && sed -i "/^${exclude}$/d" $TMP/run.tlpkg
+ [ -s $output_doc ] && sed -i "/^${exclude}$/d" $output_doc
+done < $TMP/global_exclude
-# get linenumbers of empty lines
+# Get linenumbers of empty lines
[ -z "$emptylines" ] && emptylines="$(grep -n ^$ $TMP/$db | cut -d':' -f1)"
-# sort doc- and run- packages out to avoid binfiles and sourcfile in the texmf-tree
+# Sort doc- and run- packages out to avoid binfiles and sourcfile in the texmf-tree
while read collection
do
if [ ! -s $texmf/$collection.meta ]
@@ -562,7 +469,7 @@ do
fi
done < $TMP/allpackages
-# handle biber binaries to be add-able
+# Handle biber binaries to be add-able
cat << EOF >> $TMP/run.tlpkg
biber.x86_64-linux
biber.i386-linux
@@ -573,12 +480,13 @@ EOF
packages
-# As the demanded packages are in the tarball, compress it.
+# Now the demanded packages are in the tarball, compress it.
echo "Compressing $TMP/texlive-$TARBALL-$VERSION.tar ..."
if [ -s $TMP/texlive-$TARBALL-$VERSION.tar ]
then
[ -f $TMP/texlive-$TARBALL-$VERSION.tar.xz ] && rm $TMP/texlive-$TARBALL-$VERSION.tar.xz
xz -9 -T0 $TMP/texlive-$TARBALL-$VERSION.tar || exit 1
+ md5sum $TMP/texlive-$TARBALL-$VERSION.tar.xz
ls -lah $TMP/texlive-$TARBALL-$VERSION.tar.xz
fi
diff --git a/office/texlive/slack-desc b/office/texlive/slack-desc
index 50d9fa80af..9646823dfe 100644
--- a/office/texlive/slack-desc
+++ b/office/texlive/slack-desc
@@ -6,14 +6,14 @@
# customary to leave one space after the ':' except on otherwise blank lines.
|-----handy-ruler------------------------------------------------------|
-texlive: texlive (TeXLive binaries, support files, TeX formats)
+texlive: texlive (TeX binaries, support files, and formats)
texlive:
-texlive: This package contains binaries (including xindy and
-texlive: biber), support files, TeX formats and packages, and other files
-texlive: included in the TeXLive TeX distribution. Included are input files
-texlive: for TeX, runtime configuration files, hyphenation tables, manpages,
-texlive: and the computer modern fonts.
+texlive: This package contains binaries, support files, TeX formats and
+texlive: packages,and other files included in the TeXLive TeX distribution.
+texlive: Included are input files for TeX, runtime configuration files,
+texlive: hyphenation tables, manpages, and the computer modern fonts.
+texlive:
+texlive: SlackBuilds.org has more texmf files and documentation in the
+texlive: texlive-extra, texlive-fonts, and texlive-docs packages.
texlive:
-texlive: More texmf files can be found in the texlive-extra and texlive-fonts
-texlive: packages; all of the docs can be found in the texlive-docs package.
texlive:
diff --git a/office/texlive/texlive.SlackBuild b/office/texlive/texlive.SlackBuild
index 1c00617eff..dad028499e 100644
--- a/office/texlive/texlive.SlackBuild
+++ b/office/texlive/texlive.SlackBuild
@@ -59,12 +59,23 @@ else
LIBDIRSUFFIX=""
fi
+# NOTE: Using the system version of poppler will require texlive to be
+# recompiled with pretty much every poppler update, as they almost always
+# bump the shared library version. But sometimes you do what you have
+# to do...
+SYSTEMPOPPLER=${SYSTEMPOPPLER:-YES}
+if [ "$SYSTEMPOPPLER" = "NO" ]; then
+ POPPLER="--without-system-poppler --without-system-xpdf"
+else
+ POPPLER="--with-system-poppler --with-system-xpdf"
+fi
+
rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf texlive-$SOURCEVERSION-source
-tar xvf $CWD/texlive-${SOURCEVERSION}-source.tar.xz
-cd texlive-$SOURCEVERSION-source
+tar xvf $CWD/texlive-${SOURCEVERSION}-source.tar.xz || exit 1
+cd texlive-$SOURCEVERSION-source || exit 1
chown -R root:root .
chmod -R u+w,go-w,a+rX-st .
@@ -79,12 +90,18 @@ sed -i \
texk/kpathsea/texmf.cnf
# Thanks to the lfs-folks ...
-patch -Np1 -i $CWD/patches/texlive-20170524-source-gcc7-1.patch
-patch -Np1 -i $CWD/patches/texlive-20170524-source-upstream_fixes-2.patch
+patch -Np1 -i $CWD/patches/texlive-20170524-source-gcc7-1.patch || exit 1
+patch -Np1 -i $CWD/patches/texlive-20170524-source-upstream_fixes-2.patch || exit 1
+
+## Needed on -current, 2017-10-06
+## Thanks to archlinux for the poppler-0.59 API fixup patch:
+#if [ ! "$SYSTEMPOPPLER" = "NO" ]; then
+# patch -Np1 -i $CWD/patches/texlive-poppler-0.59.patch || exit 1
+#fi
# --with-system-harfbuzz requires graphite2 (and harfbuzz linked to it)
mkdir build
-pushd build
+cd build
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
../configure \
@@ -106,8 +123,6 @@ pushd build
--disable-xindy-rules \
--with-clisp-runtime=system \
--enable-gc=system \
- --with-system-poppler \
- --with-system-xpdf \
--with-system-zlib \
--with-system-libpng \
--with-system-t1lib \
@@ -121,18 +136,24 @@ pushd build
--with-system-mpfr \
--with-system-fontconfig \
--with-system-ncurses \
- --build=$ARCH-slackware-linux
- make
- # make check
- make install-strip DESTDIR=$PKG
+ --without-system-harfbuzz \
+ $POPPLER \
+ --build=$ARCH-slackware-linux || exit 1
+
+ make || exit 1
+ # make check || exit 1
+ make install-strip DESTDIR=$PKG || exit 1
# Create symlinks
- make texlinks DESTDIR=$PKG
-popd
+ make texlinks DESTDIR=$PKG || exit 1
+cd ..
+
+# Don't ship .la files:
+rm -f $PKG/usr/lib${LIBDIRSUFFIX}/*.la
# install the texmf stuff, overwrite partly stuff coming from the source build;
# don't remove/separate koma-script docs as this is the wish of the author
mkdir -p $PKG/usr/share
-tar vxf $CWD/texlive-base-$VERSION.tar.xz -C $PKG/usr/share
+tar xvf $CWD/texlive-base-$VERSION.tar.xz -C $PKG/usr/share || exit 1
chown -R root:root $PKG
chmod -R u+w,go-w,a+rX-st $PKG
diff --git a/office/texlive/texlive.info b/office/texlive/texlive.info
index ea51c046eb..06c1343a3e 100644
--- a/office/texlive/texlive.info
+++ b/office/texlive/texlive.info
@@ -4,7 +4,7 @@ HOMEPAGE="http://tug.org/texlive/"
DOWNLOAD="http://mirrors.ctan.org/systems/texlive/Source/texlive-20170520-source.tar.xz \
http://slackware.schoepfer.info/slackbuilds/texlive/2017/texlive/texlive-base-2017.170622.tar.xz"
MD5SUM="5456dfd7858fe53cdd0fda5f0eb4fd35 \
- 29bee4e0671431334fc1dcae3e0087c0"
+ 29bee4e0671431334fc1dcae3e0087c0"
DOWNLOAD_x86_64=""
MD5SUM_x86_64=""
REQUIRES=""